/* (c) 2005 Witold Bolt */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "inter.h"

/* tu dostajemy wartosci pochodnej f rzedu d w punkcie x */
double f(double x,int d) {
		return ( (1 << d) * exp(2*x) + ((d>0) ? 0 : 1) );
}

/* tu dostajemy wielomian ... */
double* getHermitePolynominal(double *nodes, int count) {

	int *k; // k[i] = rzad pochodnej do policzenia w nodes[i]

	double *poly = (double*)malloc(count*sizeof(double)); // wielomian

	k = (int*)malloc(count*sizeof(int));

	k[0]=0;

	/* wyznaczmy rzad pochodnej w danym wezle na podstawie 
		liczby powtorzen wezla */
	for(int i=1;i<count;i++) {
		if (nodes[i] == nodes[i-1])
			k[i] = k[i-1]+1;
		else
			k[i] = 0;
	}

	/* wyliczamy wartosci funkcji i pochodnych w wezlach */
	for(int i=0;i<count;i++) {
		poly[i] = f(nodes[i],k[i]);
	}

	/* wyliczamy wspolczynniki wielomianu */
	for(int j=1;j<count;j++)
		for(int i=count-1;i>=j;i--) {
			if(k[i]==0)
				poly[i] = (poly[i] - poly[i-1-k[i-1]])/(nodes[i]-nodes[i-j]);
			else {
				poly[i] /= (double)j;
				k[i]--;
			}
		}

	/* zamiana bazy: Newton -> jednomiany */
	for(int j=count-1;j>=0;j--)
		for(int i=j;i<count-1;i++)
			poly[i] = poly[i]-poly[i+1]*nodes[j];

	return(poly);
}
